diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/channel.c ircd-hybrid-6.0/src/channel.c
--- ircd-hybrid-6.0.orig/src/channel.c	Fri Jun  8 18:03:40 2001
+++ ircd-hybrid-6.0/src/channel.c	Wed Jun  6 17:39:09 2001
@@ -443,9 +443,9 @@
     if (match(BANSTR(tmp), s) ||
 	match(BANSTR(tmp), s2))
       {
-        if (tmp->value.banptr->can_join) /* really banned? or just quieted? */
+	if (tmp->value.banptr->can_join) /* really banned? or just quieted? */
 	  return CHFL_QUIET;
-        else
+	else
 	  break;
       }
 #else
@@ -1289,7 +1289,7 @@
             }
 
           /* Immune users */
-          if ((c == 'o') && whatt == MODE_DEL && !IsPrivileged(sptr)
+          if ((c == 'o') && whatt == MODE_DEL && !(IsServer(sptr) || IsSetOperGod(sptr))
               && IsImmune(who))
             {
               sendto_one(sptr, form_str(ERR_USERISIMMUNE),
@@ -2073,7 +2073,7 @@
           /* Un documented for now , I have no idea how this got here ;-) */
 #ifdef JUPE_CHANNEL
         case 'j':
-          if(IsAnOper(sptr))
+          if(IsSetOperGod(sptr))
             {
               if (whatt == MODE_ADD)
                 {
@@ -2519,10 +2519,10 @@
 #ifdef JUPE_CHANNEL
   if( chptr->mode.mode & MODE_JUPED )
     {
-      sendto_ops_flags(FLAGS_SPY,
-             "User %s (%s@%s) is attempting to join juped channel %s",
-                     sptr->name,
-                     sptr->username, sptr->host,chptr->chname);
+      sendto_ops_flag(UMODE_SPY,
+		      "User %s (%s@%s) is attempting to join juped channel %s",
+		      sptr->name,
+		      sptr->username, sptr->host,chptr->chname);
       return (ERR_BADCHANNAME);
     }
 #endif
@@ -2626,8 +2626,8 @@
 
 #ifdef CHANNEL_CREATION_NOTICE
       if(IsPerson(cptr) && !IsServer(cptr)) {
-        sendto_ops_flags_butone(NULL, FLAGS_CHCREATE, "Channel %s created by %s!%s@%s on %s", chptr->chname, cptr->name, 
-		       cptr->username, cptr->host, me.name);
+        sendto_ops_flag_butone(NULL, UMODE_CHCREATE, "Channel %s created by %s!%s@%s on %s", chptr->chname, cptr->name, 
+			       cptr->username, cptr->host, me.name);
       }
 #endif /* CHANNEL_CREATION_NOTICE */
     }
@@ -3042,7 +3042,7 @@
            * -Dianora
            */
           server_was_split = NO;
-          sendto_ops_flags(FLAGS_SERVNOTICE, "Net rejoined, split-mode deactivated, whew");
+          sendto_ops_flag(UMODE_SERVNOTICE, "Net rejoined, split-mode deactivated, whew");
           cold_start = NO;
 #if defined(PRESERVE_CHANNEL_ON_SPLIT) || defined(NO_JOIN_ON_SPLIT)
           remove_empty_channels();
@@ -3232,7 +3232,7 @@
 
 
 #ifdef NO_JOIN_ON_SPLIT_SIMPLE
-      if (server_was_split && MyClient(sptr) && !IsAnOper(sptr))
+      if (server_was_split && MyClient(sptr) && !IsSetOperGod(sptr))
         {
               sendto_one(sptr, form_str(ERR_UNAVAILRESOURCE),
                          me.name, parv[0], name);
@@ -3248,7 +3248,7 @@
        * cold_start is set to NO if SPLITDELAY is set to 0 in m_set()
        */
 
-      if(cold_start && MyClient(sptr) && !IsAnOper(sptr))
+      if(cold_start && MyClient(sptr) && !IsSetOperGod(sptr))
         {
               sendto_one(sptr, form_str(ERR_UNAVAILRESOURCE),
                          me.name, parv[0], name);
@@ -3288,14 +3288,14 @@
 
 #ifdef ANTI_SPAMBOT       /* Dianora */
 
-          if( MyConnect(sptr) && !IsAnOper(sptr) )
+          if( MyConnect(sptr) && !IsImmune(sptr) )
             {
               if(SPAMNUM && (sptr->join_leave_count >= SPAMNUM))
                 {
-                  sendto_ops_flags_butone(NULL, FLAGS_BOTS,
-                                     "User %s (%s@%s) is a possible spambot",
-                                     sptr->name,
-                                     sptr->username, sptr->host);
+                  sendto_ops_flag_butone(NULL, UMODE_BOTS,
+					 "User %s (%s@%s) is a possible spambot",
+					 sptr->name,
+					 sptr->username, sptr->host);
                   sptr->oper_warn_count_down = OPER_SPAM_COUNTDOWN;
                 }
               else
@@ -3350,7 +3350,7 @@
             */
 
 #ifdef NO_CHANOPS_WHEN_SPLIT
-          if(!IsAnOper(sptr) && server_was_split)
+          if(!IsSetOperGod(sptr) && server_was_split)
             {
               allow_op = NO;
 
@@ -3362,7 +3362,7 @@
 #endif
 
           if ((sptr->user->joined >= MAXCHANNELSPERUSER) &&
-             (!IsAnOper(sptr) || (sptr->user->joined >= MAXCHANNELSPERUSER*3)))
+             (!IsSetOperGod(sptr) || (sptr->user->joined >= MAXCHANNELSPERUSER*3)))
             {
               sendto_one(sptr, form_str(ERR_TOOMANYCHANNELS),
                          me.name, parv[0], name);
@@ -3388,12 +3388,12 @@
  
               if(sptr->oper_warn_count_down == 0)
                 {
-                  sendto_ops_flags_butone(NULL, FLAGS_BOTS,
-                    "User %s (%s@%s) trying to join %s is a possible spambot",
-                             sptr->name,
-                             sptr->username,
-                             sptr->host,
-                             name);     
+                  sendto_ops_flag_butone(NULL, UMODE_BOTS,
+					 "User %s (%s@%s) trying to join %s is a possible spambot",
+					 sptr->name,
+					 sptr->username,
+					 sptr->host,
+					 name);     
                   sptr->oper_warn_count_down = OPER_SPAM_COUNTDOWN;
                 }
 #ifndef ANTI_SPAMBOT_WARN_ONLY
@@ -3423,7 +3423,7 @@
                 continue;
 
               /* allow local joins to this channel */
-              if( (chptr->users == 0) && !IsAnOper(sptr) )
+              if( (chptr->users == 0) && !IsSetOperGod(sptr) )
                 {
                   sendto_one(sptr, form_str(ERR_UNAVAILRESOURCE),
                              me.name, parv[0], name);
@@ -3612,14 +3612,14 @@
 #ifdef ANTI_SPAMBOT     /* Dianora */
       /* if its my client, and isn't an oper */
 
-      if (name && MyConnect(sptr) && !IsAnOper(sptr))
+      if (name && MyConnect(sptr) && !IsImmune(sptr))
         {
           if(SPAMNUM && (sptr->join_leave_count >= SPAMNUM))
             {
-              sendto_ops_flags_butone(NULL, FLAGS_BOTS,
-                               "User %s (%s@%s) is a possible spambot",
-                               sptr->name,
-                               sptr->username, sptr->host);
+              sendto_ops_flag_butone(NULL, UMODE_BOTS,
+				     "User %s (%s@%s) is a possible spambot",
+				     sptr->name,
+				     sptr->username, sptr->host);
               sptr->oper_warn_count_down = OPER_SPAM_COUNTDOWN;
             }
           else
@@ -3853,7 +3853,7 @@
   if (IsMember(who, chptr))
     {
       /* Immune users */
-      if( !IsPrivileged(sptr) && IsImmune(who) )
+      if( !(IsServer(sptr) || IsSetOperGod(sptr)) && IsImmune(who) )
         {
           sendto_one(sptr, form_str(ERR_USERISIMMUNE),
                      me.name, parv[0], user, name);
@@ -3880,10 +3880,10 @@
       remove_user_from_channel(who, chptr, 1);
       if (MyClient(sptr))
 #ifdef GODOPERS
-        sendto_ops_flags_butone(NULL, FLAGS_BOTS,
-                                "Kick from %s by %s on %s (%s@%s) [%s]",
-                                 name, sptr->name, who->name,
-                                 who->username, who->host, who->user->server);
+        sendto_ops_flag_butone(NULL, UMODE_BOTS,
+			       "Kick from %s by %s on %s (%s@%s) [%s]",
+			       name, sptr->name, who->name,
+			       who->username, who->host, who->user->server);
 #endif
     }
   else
@@ -3994,9 +3994,11 @@
 
   /* flood control server wide, clients on KNOCK
    * opers are not flood controlled.
+   *
+   * sure they are, just not godopers -- asuffield
    */
 
-  if(!IsAnOper(sptr))
+  if(!IsSetOperGod(sptr))
     {
       if((last_used + PACE_WAIT) > CurrentTime)
         return 0;
@@ -4012,7 +4014,8 @@
    */
 
   /* opers are not flow controlled here */
-  if( !IsAnOper(sptr) && (sptr->last_knock + KNOCK_DELAY) > CurrentTime)
+  /* <ahem> *god*opers are not flow controlled -- asuffield */
+  if( !IsSetOperGod(sptr) && (sptr->last_knock + KNOCK_DELAY) > CurrentTime)
     {
       sendto_one(sptr,":%s NOTICE %s :*** Notice -- Wait %d seconds before another knock",
                  me.name,
@@ -4184,11 +4187,13 @@
     }
 
 #ifdef SERVERHIDE
-  if (!IsAnOper(sptr) && parv[2][0] == '&') {
+#ifdef LOCAL_CHANNELS
+  if (!IsSetOperGod(sptr) && parv[2][0] == '&') {
     sendto_one(sptr, ":%s NOTICE %s :INVITE to local channels is disabled in this server",
                me.name, parv[0]);
     return 0;
   }
+#endif
 #endif
 
   /* A little sanity test here */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/client.c ircd-hybrid-6.0/src/client.c
--- ircd-hybrid-6.0.orig/src/client.c	Fri Jun  8 18:03:38 2001
+++ ircd-hybrid-6.0/src/client.c	Wed Jun  6 18:59:44 2001
@@ -55,6 +55,10 @@
 #include <unistd.h>
 #include <sys/stat.h>
 
+struct  bitfield_lookup_t bitfield_lookup[BITFIELD_SIZE];
+umode_t user_umodes;
+umode_t send_umodes;
+umode_t all_umodes;
 
 /* 
  * Number of struct Client structures to preallocate at a time
@@ -325,8 +329,8 @@
                       continue;
                     }
 
-		      sendto_ops_flags_butone(NULL, FLAGS_SKILL, "%s confirms D-line of %s", me.name,
-                                 get_client_name(cptr, FALSE));
+		      sendto_ops_flag_butone(NULL, UMODE_SKILL, "%s confirms D-line of %s", me.name,
+					     get_client_name(cptr, FALSE));
 
                   dying_clients[die_index] = cptr;
 /* Wintrhawk */
@@ -368,7 +372,7 @@
 #ifdef GLINES
                   if( (aconf = find_gkill(cptr,cptr->username)) )
                     {
-		      sendto_ops_flags_butone(NULL, FLAGS_SKILL, "%s confirms G-line of %s", me.name,
+		      sendto_ops_flag_butone(NULL, UMODE_SKILL, "%s confirms G-line of %s", me.name,
                                  get_client_name(cptr, FALSE));
 
                       dying_clients[die_index] = cptr;
@@ -406,7 +410,7 @@
                                      continue;
                         }
 
-		      sendto_ops_flags_butone(NULL, FLAGS_SKILL, "%s confirms kill of %s", me.name,
+		      sendto_ops_flag_butone(NULL, UMODE_SKILL, "%s confirms kill of %s", me.name,
                                  get_client_name(cptr, FALSE));
                       dying_clients[die_index] = cptr;
 
@@ -673,7 +677,7 @@
         {
           if (!server_was_split)
             {
-              sendto_ops_flags(FLAGS_SERVNOTICE, "Netsplit detected, split-mode activated, hope for the best");
+              sendto_ops_flag(UMODE_SERVNOTICE, "Netsplit detected, split-mode activated, hope for the best");
               server_was_split = YES;
             }
           server_split_time = CurrentTime;
@@ -1492,15 +1496,15 @@
       sptr->flags |= FLAGS_CLOSING;
       if (IsPerson(sptr))
         {
-          sendto_ops_flags_butone(NULL, FLAGS_CCONN,
-                               "Client exiting: %s (%s@%s) [%s] [%s] [%s]",
-                               sptr->name, sptr->username, sptr->host,
+          sendto_ops_flag_butone(NULL, UMODE_CCONN,
+				 "Client exiting: %s (%s@%s) [%s] [%s] [%s]",
+				 sptr->name, sptr->username, sptr->host,
 #ifdef WINTRHAWK
-                               comment,
+				 comment,
 #else
-               (sptr->flags & FLAGS_NORMALEX) ?  "Client Quit" : comment,
+				 (sptr->flags & FLAGS_NORMALEX) ?  "Client Quit" : comment,
 #endif /* WINTRHAWK */
-                               sptr->sockhost, me.name);
+				 sptr->sockhost, me.name);
         }
 #ifdef FNAME_USERLOG
           on_for = CurrentTime - sptr->firsttime;
@@ -1605,9 +1609,9 @@
 
       if (sptr->servptr == &me)
         {
-          sendto_ops_flags_butone(NULL, FLAGS_SERVNOTICE, "%s was connected to %s for %d seconds.  %d/%d sendK/recvK.",
-                     sptr->name, &me.name, CurrentTime - sptr->firsttime,
-                     sptr->sendK, sptr->receiveK);
+          sendto_ops_flag_butone(NULL, UMODE_SERVNOTICE, "%s was connected to %s for %d seconds.  %d/%d sendK/recvK.",
+				 sptr->name, &me.name, CurrentTime - sptr->firsttime,
+				 sptr->sendK, sptr->receiveK);
           log(L_NOTICE, "%s was connected for %d seconds.  %d/%d sendK/recvK.",
               sptr->name, CurrentTime - sptr->firsttime, 
               sptr->sendK, sptr->receiveK);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/fdlist.c ircd-hybrid-6.0/src/fdlist.c
--- ircd-hybrid-6.0.orig/src/fdlist.c	Sat Jul 24 08:58:57 1999
+++ ircd-hybrid-6.0/src/fdlist.c	Tue Jun  5 13:19:46 2001
@@ -62,7 +62,7 @@
 
       if (!(cptr = local[i])) 
         continue;
-      if (IsServer(cptr) || IsAnOper(cptr))
+      if (IsServer(cptr) || IsAlwaysBusy(cptr))
           continue;
 
       GlobalFDList[i] &= ~FDL_BUSY;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/flud.c ircd-hybrid-6.0/src/flud.c
--- ircd-hybrid-6.0.orig/src/flud.c	Fri Jun  8 18:03:36 2001
+++ ircd-hybrid-6.0/src/flud.c	Wed Jun  6 17:40:16 2001
@@ -58,27 +58,27 @@
   switch(type)
     {
     case 1: /* classic CTCP */
-      sendto_ops_flags_butone(NULL, FLAGS_BOTS, "Flooder %s [%s@%s] on %s target: %s (ctcp %i)",
-                       fluder->name, fluder->username, fluder->host,
-                       fluder->user->server, fludee, fluder->repeatcount);
+      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (ctcp %i)",
+			     fluder->name, fluder->username, fluder->host,
+			     fluder->user->server, fludee, fluder->repeatcount);
       break;
     case 2: /* repeating channel traffic */
-      sendto_ops_flags_butone(NULL, FLAGS_BOTS, "Flooder %s [%s@%s] on %s target: %s (echo %i)",
+      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (echo %i)",
                        fluder->name, fluder->username, fluder->host,
                        fluder->user->server, fludee, fluder->repeatcount);
       break;
     case 3: /* repeating oneself */
-      sendto_ops_flags_butone(NULL, FLAGS_BOTS, "Flooder %s [%s@%s] on %s target: %s (spam %i)",
+      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (spam %i)",
                        fluder->name, fluder->username, fluder->host,
                        fluder->user->server, fludee, fluder->repeatcount);
       break;
     case 4: /* insane message lengths */
-      sendto_ops_flags_butone(NULL, FLAGS_BOTS, "Flooder %s [%s@%s] on %s target: %s (len %i)",
+      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s (len %i)",
                        fluder->name, fluder->username, fluder->host,
                        fluder->user->server, fludee, fluder->lastlen);
       break;
     default:
-      sendto_ops_flags_butone(NULL, FLAGS_BOTS, "Flooder %s [%s@%s] on %s target: %s",
+      sendto_ops_flag_butone(NULL, UMODE_BOTS, "Flooder %s [%s@%s] on %s target: %s",
                        fluder->name, fluder->username, fluder->host,
                        fluder->user->server, fludee);
       break;
@@ -170,7 +170,7 @@
   int flud = 0;
   int len;
 
-  if (!MyConnect(fluder) || IsPrivileged(fluder))
+  if (!MyConnect(fluder) || IsServer(fluder) || NoFloodProtection(fluder))
     return 0;
 
   if ((len = strlen(message)) > 160)
@@ -425,8 +425,8 @@
 #ifdef DEATHFLUD
   if (blocking && fluder->repeatcount > KILLNUM)
     {
-      sendto_ops_flags(FLAGS_SKILL, "Flood countermeasure, dumping user %s",
-                       fluder->name);
+      sendto_ops_flag(UMODE_SKILL, "Flood countermeasure, dumping user %s",
+		      fluder->name);
       sendto_one(fluder, ":%s KILL %s :%s spam",
                  me.name, fluder->name, cptr->name);
       exit_client(fluder, fluder, &me, "Excessive spam");
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/hash.c ircd-hybrid-6.0/src/hash.c
--- ircd-hybrid-6.0.orig/src/hash.c	Tue Feb  1 00:44:11 2000
+++ ircd-hybrid-6.0/src/hash.c	Tue Jun  5 11:32:02 2001
@@ -460,7 +460,7 @@
   char  hash_log_file[256];
   char  timebuffer[MAX_DATE_STRING];
 
-  if (!MyClient(sptr) || !IsOper(sptr))
+  if (!MyClient(sptr) || !IsDebugger(sptr))
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/ircd.c ircd-hybrid-6.0/src/ircd.c
--- ircd-hybrid-6.0.orig/src/ircd.c	Fri Jun  8 18:03:36 2001
+++ ircd-hybrid-6.0/src/ircd.c	Tue Jun  5 11:17:25 2001
@@ -51,6 +51,7 @@
 #include "send.h"
 #include "struct.h"
 #include "whowas.h"
+#include "s_user.h"
 
 #include <stdlib.h>
 #include <string.h>
@@ -662,7 +663,9 @@
   uid_t       euid;
   time_t      delay = 0;
   aConfItem*  aconf;
+#ifndef OPN_DEBUG
   struct passwd *pass;
+#endif
 #ifdef SAVE_MAXCLIENT
   FBFILE* file;
   char mline[20];
@@ -852,6 +855,7 @@
   initwhowas();
   init_stats();
   init_tree_parse(msgtab);      /* tree parse code (orabidoo) */
+  init_umodes();                /* fill in the umode lookup table -- asuffield */
 
   fdlist_init();
   init_netio();
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/listener.c ircd-hybrid-6.0/src/listener.c
--- ircd-hybrid-6.0.orig/src/listener.c	Fri Jun  8 18:03:38 2001
+++ ircd-hybrid-6.0/src/listener.c	Tue Jun  5 13:20:30 2001
@@ -118,7 +118,7 @@
        flags[i] = '\0';
        
        /* Don't send hidden ports */
-       if (!listener->hidden_port || IsAnOper(sptr))
+       if (!listener->hidden_port || SeesAllConnections(sptr))
 	 sendto_one(sptr, form_str(RPL_STATSPLINE),
 		    me.name,
 		    sptr->name,
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_admin.c ircd-hybrid-6.0/src/m_admin.c
--- ircd-hybrid-6.0.orig/src/m_admin.c	Sat Nov 11 02:30:23 2000
+++ ircd-hybrid-6.0/src/m_admin.c	Wed Jun  6 17:36:21 2001
@@ -97,7 +97,7 @@
   struct ConfItem *aconf;
   static time_t last_used=0L;
 
-  if(!IsAnOper(sptr))
+  if(!NoFloodProtection(sptr))
     {
       if((last_used + PACE_WAIT) > CurrentTime)
         {
@@ -114,9 +114,9 @@
     return 0;
 
   if (IsPerson(sptr))
-    sendto_realops_flags(FLAGS_SPY,
-                         "ADMIN requested by %s (%s@%s) [%s]", sptr->name,
-                         sptr->username, sptr->host, sptr->user->server);
+    sendto_realops_flag(UMODE_SPY,
+			"ADMIN requested by %s (%s@%s) [%s]", sptr->name,
+			sptr->username, sptr->host, sptr->user->server);
   if ((aconf = find_admin()))
     {
       sendto_one(sptr, form_str(RPL_ADMINME),
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_away.c ircd-hybrid-6.0/src/m_away.c
--- ircd-hybrid-6.0.orig/src/m_away.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/m_away.c	Wed Jun  6 17:36:28 2001
@@ -115,8 +115,8 @@
   /* make sure the user exists */
   if (!(sptr->user))
     {
-      sendto_realops_flags(FLAGS_DEBUG,
-                           "Got AWAY from nil user, from %s (%s)\n",cptr->name,sptr->name);
+      sendto_realops_flag(UMODE_DEBUG,
+			  "Got AWAY from nil user, from %s (%s)\n",cptr->name,sptr->name);
       return 0;
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_connect.c ircd-hybrid-6.0/src/m_connect.c
--- ircd-hybrid-6.0.orig/src/m_connect.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/m_connect.c	Wed Jun  6 17:36:50 2001
@@ -112,9 +112,12 @@
   struct ConfItem* aconf;
   struct Client*   acptr;
 
-  if (!IsPrivileged(sptr))
+  if (!(IsServer(sptr) || CanConnect(sptr)))
     {
-      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      if (SeesOperMessages(sptr))
+	sendto_one(sptr,":%s NOTICE %s :You have no R umode", me.name, parv[0]);
+      else
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return -1;
     }
 
@@ -125,9 +128,9 @@
     return 0;
   }
 
-  if (MyConnect(sptr) && !IsOperRemote(sptr) && parc > 3)
+  if (MyConnect(sptr) && !IsSetOperRemote(sptr) && parc > 3)
     {
-      sendto_one(sptr,":%s NOTICE %s :You have no R flag", me.name, parv[0]);
+      sendto_one(sptr,":%s NOTICE %s :You have no R umode", me.name, parv[0]);
       return 0;
     }
 
@@ -186,12 +189,12 @@
   /*
    * Notify all operators about remote connect requests
    */
-  if (!IsAnOper(cptr))
+  if (IsServer(cptr))
     {
-      sendto_ops_butone(NULL, &me,
-                        ":%s WALLOPS :Remote CONNECT %s %s from %s",
-                        me.name, parv[1], parv[2] ? parv[2] : "",
-                        get_client_name(sptr, FALSE));
+      sendto_ops_flag_butone(NULL, UMODE_SERVNOTICE,
+			     "Remote CONNECT %s %s from %s",
+			     parv[1], parv[2] ? parv[2] : "",
+			     get_client_name(sptr, FALSE));
 
       log(L_TRACE, "CONNECT From %s : %s %s", 
           parv[0], parv[1], parv[2] ? parv[2] : "");
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_die.c ircd-hybrid-6.0/src/m_die.c
--- ircd-hybrid-6.0.orig/src/m_die.c	Fri Jun  8 18:03:35 2001
+++ ircd-hybrid-6.0/src/m_die.c	Tue Jun  5 14:35:12 2001
@@ -96,15 +96,12 @@
   struct Client* acptr;
   int      i;
 
-  if (!MyClient(sptr) || !IsAnOper(sptr))
+  if (!MyClient(sptr) || !IsSetOperDie(sptr))
     {
-      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
-      return 0;
-    }
-
-  if (!IsOperDie(sptr))
-    {
-      sendto_one(sptr,":%s NOTICE %s :You have no D flag", me.name, parv[0]);
+      if (SeesOperMessages(sptr))
+	sendto_one(sptr,":%s NOTICE %s :You have no D umode", me.name, parv[0]);
+      else
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
     }
 
@@ -130,7 +127,7 @@
         continue;
       if (IsClient(acptr))
         {
-          if(IsAnOper(acptr))
+          if(IsSetOperAuspex(acptr))
             sendto_one(acptr,
                        ":%s NOTICE %s :Server Terminating. %s",
                        me.name, acptr->name,
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_gline.c ircd-hybrid-6.0/src/m_gline.c
--- ircd-hybrid-6.0.orig/src/m_gline.c	Fri Jun  8 18:03:36 2001
+++ ircd-hybrid-6.0/src/m_gline.c	Tue Jun  5 12:22:06 2001
@@ -118,15 +118,12 @@
     {
 #ifdef GLINES
       /* Only globals can apply Glines */
-      if (!IsOper(sptr))
-        {
-          sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
-          return 0;
-        }
-
       if (!IsSetOperGline(sptr))
         {
-          sendto_one(sptr,":%s NOTICE %s :You have no G flag",me.name,parv[0]);
+	  if (!SeesOperMessages(sptr))
+	    sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+	  else
+	    sendto_one(sptr,":%s NOTICE %s :You have no G umode",me.name,parv[0]);
           return 0;
         }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_help.c ircd-hybrid-6.0/src/m_help.c
--- ircd-hybrid-6.0.orig/src/m_help.c	Thu Jul 29 08:11:48 1999
+++ ircd-hybrid-6.0/src/m_help.c	Tue Jun  5 14:38:33 2001
@@ -97,7 +97,7 @@
   int i;
   static time_t last_used = 0;
 
-  if (!IsAnOper(sptr))
+  if (!NoFloodProtection(sptr))
     {
       /* HELP is always local */
       if ((last_used + PACE_WAIT) > CurrentTime)
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_htm.c ircd-hybrid-6.0/src/m_htm.c
--- ircd-hybrid-6.0.orig/src/m_htm.c	Fri Jul 30 07:40:14 1999
+++ ircd-hybrid-6.0/src/m_htm.c	Tue Jun  5 12:22:30 2001
@@ -98,7 +98,7 @@
 {
   char *command;
 
-  if (!MyClient(sptr) || !IsOper(sptr))
+  if (!MyClient(sptr) || !SeesOperMessages(sptr))
     {
       sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
@@ -110,6 +110,11 @@
           LRV, currlife);
   if (parc > 1)
     {
+      if (!IsSetOperRemote(sptr))
+	{
+	  sendto_one(sptr,":%s NOTICE %s :You have no R umode",me.name,parv[0]);
+	  return 0;
+	}
       command = parv[1];
       if (!irccmp(command,"TO"))
         {
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_info.c ircd-hybrid-6.0/src/m_info.c
--- ircd-hybrid-6.0.orig/src/m_info.c	Tue Nov 21 06:49:29 2000
+++ ircd-hybrid-6.0/src/m_info.c	Wed Jun  6 17:36:56 2001
@@ -36,11 +36,11 @@
 
   if (hunt_server(cptr,sptr,":%s INFO :%s",1,parc,parv) == HUNTED_ISME)
   {
-    sendto_realops_flags(FLAGS_SPY, "info requested by %s (%s@%s) [%s]",
+    sendto_realops_flag(UMODE_SPY, "info requested by %s (%s@%s) [%s]",
       sptr->name, sptr->username, sptr->host,
       sptr->user->server);
 
-    if (!IsAnOper(sptr))
+    if (!NoFloodProtection(sptr))
     {
       /* reject non local requests */
       if (!MyConnect(sptr))
@@ -53,7 +53,7 @@
       }
       else
         last_used = CurrentTime;
-    } /* if (!IsAnOper(sptr)) */
+    }
 
     while (*text)
       sendto_one(sptr, form_str(RPL_INFO), me.name, parv[0], *text++);
@@ -64,7 +64,7 @@
      * Now send them a list of all our configuration options
      * (mostly from config.h)
      */
-    if (IsAnOper(sptr))
+    if (IsDebugger(sptr))
     {
       for (infoptr = MyInformation; infoptr->name; infoptr++)
       {
@@ -95,7 +95,7 @@
         parv[0],
         platform);
 #endif
-    } /* if (IsAnOper(sptr)) */
+    }
 
     sendto_one(sptr, form_str(RPL_INFO), me.name, parv[0], "");
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_ison.c ircd-hybrid-6.0/src/m_ison.c
--- ircd-hybrid-6.0.orig/src/m_ison.c	Thu Oct 14 07:14:43 1999
+++ ircd-hybrid-6.0/src/m_ison.c	Tue Jun  5 12:27:41 2001
@@ -125,8 +125,10 @@
   len = strlen(buf);
   current_insert_point = buf + len;
 
-  if (!IsOper(cptr))
-    cptr->priority +=20; /* this keeps it from moving to 'busy' list */
+  /* opers get no special treatment now, ISON will always decrease your priority
+   *  -- asuffield
+   */
+  cptr->priority +=20; /* this keeps it from moving to 'busy' list */
 
   current_nick = parv[1];
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_kill.c ircd-hybrid-6.0/src/m_kill.c
--- ircd-hybrid-6.0.orig/src/m_kill.c	Tue Nov 21 06:49:29 2000
+++ ircd-hybrid-6.0/src/m_kill.c	Wed Jun  6 17:37:20 2001
@@ -125,13 +125,13 @@
       return 0;
     }
 
-  if (MyClient(sptr) && IsAnOper(sptr) && !IsSetOperK(sptr))
+  if (MyClient(sptr) && !IsSetOperK(sptr))
     {
-      sendto_one(sptr,":%s NOTICE %s :You have no K flag",me.name,parv[0]);
+      sendto_one(sptr,":%s NOTICE %s :You have no K umode",me.name,parv[0]);
       return 0;
     }
 
-  if (IsAnOper(cptr))
+  if (!IsServer(cptr)) /* It originated here; parv[2] is a reason, so clip it's length */
     {
       if (!BadPtr(path))
         if (strlen(path) > (size_t) KILLLEN)
@@ -167,7 +167,7 @@
       return 0;
     }
 
-  if (MyOper(sptr) && !MyConnect(acptr) && (!IsOperGlobalKill(sptr)))
+  if (MyOper(sptr) && !MyConnect(acptr) && !IsSetOperGlobalKill(sptr))
     {
       sendto_one(sptr, ":%s NOTICE %s :Nick %s isnt on your server",
                  me.name, parv[0], acptr->name);
@@ -189,7 +189,7 @@
         {
           ircsprintf(buf, "%s!%s%s (%s)",
                      cptr->username, cptr->name,
-                     IsOper(sptr) ? "" : "(L)", path);
+                     IsLocOp(sptr) ? "(L)" : "", path);
           path = buf;
           reason = path;
         }
@@ -218,7 +218,7 @@
     }
   else
     {
-      if(IsAnOper(cptr))
+      if(!IsServer(cptr))
         {
           reason = parv[2];
         }
@@ -232,7 +232,7 @@
 	}
     }
 
-  if (IsAnOper(sptr)) /* send it normally */
+  if (!IsServer(sptr)) /* send it normally */
     {
       sendto_realops("Received KILL message for %s. From %s Path: %s!%s", 
                acptr->name, parv[0], inpath, path);
@@ -247,12 +247,12 @@
        */
     }
   else
-    sendto_realops_flags(FLAGS_SKILL,
-                     "Received KILL message for %s. From %s",
-                     acptr->name, parv[0]);
+    sendto_realops_flag(UMODE_SKILL,
+			"Received KILL message for %s. From %s",
+			acptr->name, parv[0]);
 
 #if defined(USE_SYSLOG) && defined(SYSLOG_KILL)
-  if (IsOper(sptr))
+  if (!IsServer(sptr))
     log(L_INFO,"KILL From %s For %s Path %s!%s",
                         parv[0], acptr->name, inpath, path);
 #endif
@@ -262,7 +262,7 @@
   ** back.
   ** Suicide kills are NOT passed on --SRB
   */
-  if (!MyConnect(acptr) || !MyConnect(sptr) || !IsAnOper(sptr))
+  if (!MyConnect(acptr) || !MyConnect(sptr) || IsServer(sptr))
     {
       sendto_serv_butone(cptr, ":%s KILL %s :%s!%s",
                          parv[0], acptr->name, inpath, path);
@@ -293,7 +293,7 @@
   ** the unnecessary QUIT for this. (This flag should never be
   ** set in any other place)
   */
-  if (MyConnect(acptr) && MyConnect(sptr) && IsAnOper(sptr))
+  if (MyConnect(acptr) && MyConnect(sptr) && !IsServer(sptr))
 #ifdef SERVERHIDE
     ircsprintf(buf2, "Killed (%s): %s",
 #else
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_kline.c ircd-hybrid-6.0/src/m_kline.c
--- ircd-hybrid-6.0.orig/src/m_kline.c	Fri Jun  8 18:03:37 2001
+++ ircd-hybrid-6.0/src/m_kline.c	Tue Jun  5 16:56:19 2001
@@ -423,15 +423,12 @@
   else
 #endif
     {
-      if (!MyClient(sptr) || !IsAnOper(sptr))
+      if (!MyClient(sptr) || !IsSetOperK(sptr))
         {
-          sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
-          return 0;
-        }
-
-      if(!IsSetOperK(sptr))
-        {
-          sendto_one(sptr,":%s NOTICE %s :You have no K flag",me.name,parv[0]);
+	  if (!SeesOperMessages(sptr))
+	    sendto_one(sptr,":%s NOTICE %s :You have no K umode",me.name,parv[0]);
+	  else
+	    sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
           return 0;
         }
 
@@ -1022,15 +1019,12 @@
   const char* current_date;
   const char *dconf;
 
-  if (!MyClient(sptr) || !IsAnOper(sptr))
+  if (!MyClient(sptr) || !IsSetOperK(sptr))
     {
-      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
-      return 0;
-    }
-
-  if(!IsSetOperK(sptr))
-    {
-      sendto_one(sptr,":%s NOTICE %s :You have no K flag",me.name,parv[0]);
+      if (!SeesOperMessages(sptr))
+	sendto_one(sptr,":%s NOTICE %s :You have no K umode",me.name,parv[0]);
+      else
+	sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
       return 0;
     }
 
